﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
#End Region

Sub Process_Globals
	Private server As HttpServer
	Private templates As Map
	Private su As StringUtils
	Public port As Int = 5555
	Public greeting As String
	Public MainPaused As Boolean
	Private updateTimer As Timer
	Dim consumption, Production, feedIn, selfConsumption, purchased As String
	Dim justWoke As Boolean = False
	
	
End Sub
Sub Service_Create
	server.Initialize("Server")
	server.Start(port)
	templates.Initialize
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo("Http Server is running", "", Main)
	Service.StartForeground(1, n)
	
	updateTimer.Initialize("upDateSE",300000) 'every 5 min - the solarEdge info is only given for 15 min intervals but
	'SolarEdge limit to 300 requests a day so min time interval is 4.8 minutes
	'Would be better to call every 15 min
	updateTimer.Enabled = False
	DownloadQuote
	updateTimer.Enabled = True
	#if DEBUG
	'ReadAMData ' don't read at create becaus eAM won't have been able to get anty data from us
	#End if
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Server_HandleRequest (Request As ServletRequest, Response As ServletResponse)
	Try
		
		
		Log("Client: " & Request.RemoteAddress)
		Log(Request.GetParameter("solar")) 'handle the request based on the URL
		'Main.AMsent = Request.GetParameter("solar")
		Select True
			Case Request.GetParameter("solar").ToUpperCase = "PRODUCTION"
				'HandleMainPage (Response, Main.Production)
				Response.SendString( Production)
			Case Request.GetParameter("solar").ToUpperCase = "CONSUMPTION"
				'HandleMainPage (Response, Main.consumption)
				Response.SendString( consumption)
			Case Request.GetParameter("solar").ToUpperCase = "PURCHASE"
				'HandleMainPage (Response, Main.consumption - Main.Production)
				Response.SendString(  (purchased - feedIn))
'			Case Request.RequestURI = "/"
'				HandleMainPage (Response)
'			Case Request.RequestURI.StartsWith("/?value")
'			'Case Request.RequestURI.StartsWith("/list/")
'				HandleList (Request, Response)
'			Case Request.RequestURI.StartsWith("/download/")
'				SetContentType(Request.RequestURI, Response)
'				Response.SendFile("", DecodePath(Request.RequestURI.SubString(9)))
'			Case Request.RequestURI.StartsWith("/upload/")
'				HandleUpload(Request, Response)
'			Case Else
'				'send a file as a response (this section is enough in order to host a site)
'				SetContentType(Request.RequestURI, Response)
'				Response.SendFile(File.DirAssets, DecodePath(Request.RequestURI.SubString(1)))
		End Select
	Catch
		Response.Status = 500
		Log("Error serving request: " & LastException)
		Response.SendString("Error serving request: " & LastException)
	End Try
	If MainPaused = False Then
		CallSubDelayed(Main,"ledON")
	    Log("called ledON")
		If justWoke = False Then
			CallSubDelayed(Main, "updateLData")
			justWoke = True
		Else
			justWoke = False
		End If
	End If
End Sub

Sub HandleMainPage (Response As ServletResponse, dataval As String)
'	Dim MainPage As String = GetTemplate("main_template.html") 'load the template from the assets folder
'	MainPage = MainPage.Replace("$TIME$", DateTime.Time(DateTime.Now))
'	Dim p As Phone
'	Dim information As StringBuilder
'	information.Initialize
'	information.Append("Model: ").Append(p.Model).Append("<br/>")
'	information.Append("SDK: ").Append(p.SdkVersion).Append("<br/>")
'	information.Append("Product: ").Append(p.Product).Append("<br/>")
'	information.Append("Manufacturer: ").Append(p.Manufacturer).Append("<br/>")
'	MainPage = MainPage.Replace("$OTHERINFORMATION$", information)
'	MainPage = MainPage.Replace("$GREETING$", greeting)
'	Response.SetContentType("text/html")
	Response.SendString(dataval)  'MainPage)
	'Main.AMsent = dataval
End Sub

Sub HandleUpload (Request As ServletRequest, Response As ServletResponse)
	Dim CurrentPath As String = DecodePath(Request.RequestURI.SubString("/upload/".Length))
	Dim upload As String = Request.GetUploadedFile("upfile")
	'copy the temporary file to the correct folder
	File.Copy(server.TempFolder, upload, CurrentPath, Request.GetParameter("upfile")) 'the file name is sent as a parameter
	File.Delete(server.TempFolder, upload) 'delete the temporary file.
	Response.SendRedirect("/list/" & EncodePath(CurrentPath)) 'redirect to the list page
End Sub

Sub HandleList(Request As ServletRequest, Response As ServletResponse)
	Dim CurrentPath As String = DecodePath(Request.RequestURI.SubString(6)) 'remove /list/
	If CurrentPath = "" Then CurrentPath = File.DirRootExternal.SubString(1) 'remove the first slash
	Dim listSb As StringBuilder
	listSb.Initialize
	listSb.Append("<ul>Files in ").Append(CurrentPath).Append(":</b><br/>")
	Dim all, files, folders As List
	files.Initialize
	folders.Initialize
	all = File.ListFiles(CurrentPath)
	If all.IsInitialized = False Then
		Response.SendString("Cannot access folder.")
		Return
	End If
	For Each f As String In all
		If File.IsDirectory(CurrentPath, f) Then
			folders.Add(f)
		Else
			files.Add(f)
		End If
	Next
	folders.Add("..") 'up folder
	folders.SortCaseInsensitive(True)
	files.SortCaseInsensitive(True)
	For Each f As String In folders
		listSb.Append("<li>")
		listSb.Append("<a href='/list/").Append(EncodePath(File.Combine(CurrentPath, f))).Append("/'>").Append(f).Append("</a>")
		listSb.Append("</li>")
	Next
	For Each f As String In files
		listSb.Append("<li>")
		listSb.Append(f).Append(" (").Append("<a href='/download/").Append(EncodePath(File.Combine(CurrentPath, f))).Append("'>View</a>)")
		listSb.Append("</li>")
	Next
	listSb.Append("</ul>")
	Dim listPage As String = GetTemplate("list_template.html")
	listPage = listPage.Replace("$UPLOADACTION$", "/upload/" & EncodePath(CurrentPath))
	listPage = listPage.Replace("$LIST$", listSb)
	Response.SetContentType("text/html")
	Response.SendString(listPage)
End Sub

Sub DownloadQuote
	Dim j As HttpJob
	Dim str1, str2, str3 As String
	Dim tNow As Long
	Dim Hrs, mns, scs, lastQuarter, prevQuarter As Long
	Dim  sQ1, sQ2 As String
	
	
	updateTimer.Enabled = False ' in case this sub takes long time though - could do if providing web pages
	'tFrom = DateTime.now - 1000*60*35 '35 minutes ago because we want one reading for 15min ago
	'tFrom = DateTime.now - 1000*60*18  '20 minutes ago so we are sure to get a 15 min interval in that range
	Try
	j.Initialize("", Me) 'name is empty as it is no longer needed
	'j.Download("http://192.168.1.198?android=hello")
	'

	
	'next line works so keep for reference
	str1 = "https://monitoringapi.solaredge.com/site/1/powerDetails?meters=PRODUCTION,CONSUMPTION,SelfConsumption,FeedIn,Purchased&startTime="
	str2 = "&api_key=555"
	tNow = DateTime.now - DateTime.TicksPerMinute *5  ' we'll allow 5 minutes for the data to be updated on SolarEdge server. I tried 3 and problems
	
	'lastQuarter = Floor(tNow/(DateTime.TicksPerMinute*15)) * DateTime.TicksPerMinute*15
	
	prevQuarter = Floor(tNow/(DateTime.TicksPerMinute*15)) * DateTime.TicksPerMinute*15
	lastQuarter = prevQuarter + DateTime.TicksPerMinute*2
	Log("lastQuarter = " & lastQuarter)
	'prevQuarter = lastQuarter - DateTime.TicksPerMinute*15
	
	
	
	
	
	#If DEBUG and TESTS
	Log("In DEBUG MODE!!!!!!")
	'Next line is an example where the FeedIn was 43W. But at the same time Purchased was 38W so Purchase was -5. How is there Purchased > 0 AND FeedIn > 0 ???
	sQ2 = "https://monitoringapi.solaredge.com/site/986664/powerDetails?meters=PRODUCTION,CONSUMPTION,SelfConsumption,FeedIn,Purchased&startTime=2019-09-30%2013:00:00&endTime=2019-09-30%2013:15:00&api_key=Q2K2VOH25Z5YNPYSCO9LS3J8ZZ7C5LN1"
	Log(sQ2)
		j.Download(sQ2)
	'            https://monitoringapi.solaredge.com/site/986664/power?startTime=2019-09-27%2022:30:00&endTime=2019-09-27%2022:45:00&api_key=Q2K2VOH25Z5YNPYSCO9LS3J8ZZ7C5LN1
		
	'j.Download("https://monitoringapi.solaredge.com/site/986664/powerDetails?meters=Production,consumption,selfConsumption,feedIn,purchased&startTime=2019-09-30%2017:45:00&endTime=2019-09-30%2020:50:00&api_key=Q2K2VOH25Z5YNPYSCO9LS3J8ZZ7C5LN1")
		
	#Else
	sQ1 = Datetimestring(prevQuarter) & "&endTime="
	
	sQ2 = Datetimestring(lastQuarter)
	
	j.Download(str1 & sQ1 & sQ2 & str2)
	#End if
	
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Log(j.GetString)
		
		Dim JSON As JSONParser
		Dim Map1, ameter As Map
		'Dim contentsList As List
		
		
		JSON.Initialize(j.getstring)
		Map1.initialize
		Map1 = JSON.NextObject
		
		Dim hMap, vMap As Map 'helper map for navigating
		Dim MeterItems, meterVal As List
	'	Dim dp As Int
		Dim stype As String
		
		vMap.Initialize
		hMap.Initialize
		ameter.initialize
		
		
		hMap = Map1.Get("powerDetails")
		MeterItems.Initialize2(hMap.Get("meters"))
		
		For i = 0 To MeterItems.Size - 1
			ameter = MeterItems.get(i)
			stype = ameter.Get("type")
			meterVal.Initialize2(ameter.Get("values"))
			vMap = meterVal.get(0)
			Map1.values
			Log(stype & " = " & vMap.Get("value") )
			
			Select stype
				Case "Consumption"
					
					consumption = Round(vMap.Get("value") +0.4)
					
				Case "SelfConsumption"
				
					selfConsumption = Round(vMap.Get("value") + 0.4)
					
				Case "Production"
					Dim svd As String
					
'					Dim hh As Int
'					hh = DateTime.GetHour(DateTime.Now)
'					If hh > 7 And hh < 19 Then
					Production = 0
					For Each mKey As String In vMap.Keys
						' "value" key can be missing when no production
						If mKey = "value" Then
							Production = Round(vMap.Get("value") + 0.01)  'if value is say 0.13
						End If
					Next
						
'					Else
'						Production = "0"
'					End If
						
				Case "Purchased"
					purchased = Round(vMap.Get("value") + 0.4)
					
				Case "FeedIn"
					feedIn = Round(vMap.Get("value") + 0.4)
				
			End Select
		
		Next
		Dim sp As String
		sp = prevQuarter
		
		'Dim sa() As String = Array (consumption, selfConsumption, Production, purchased, feedIn, sp)
		Main.consumption=consumption
		Main.selfConsumption=selfConsumption
		Main.Production=Production
		Main.purchased=purchased
		Main.feedIn=feedIn
		Main.prevQuarter=prevQuarter
		
		If MainPaused = False Then CallSubDelayed(Main, "updateLData")
		', Array As String("consumption",consumption, "selfConsumption",selfConsumption, "Production",Production, "purchased",purchased, "feedIn",feedIn,"prevQuarter",prevQuarter) )
'		EditText1.Text =     "       Values at " & timestring(prevQuarter) & CRLF _
'		                   & "    Consumption: " & Pad(consumption,-5) & " W" & CRLF _
'		                   & "     Production: " & Pad(Production,-5) & " W"  & CRLF _
'						   & "         FeedIn: " & Pad(feedIn,-5) & " W" & CRLF _
'						   & "SelfConsumption: " & Pad(selfConsumption,-5) & " W" & CRLF _
'						   & "      Purchased: " & Pad(purchased,-5) & " W" & CRLF & CRLF
'						   
'		EditText1.Text = EditText1.Text & "=========================" & CRLF & CRLF
'		
'		EditText1.Text = EditText1.Text & "Values for AM -" & CRLF & CRLF _
'		                   & "   Consumption = " & Pad(consumption,-5) & CRLF _
'						   & "    Production = " & Pad(Production,-5) & CRLF _
'						   & "      Purchase = " & Pad( purchased - feedIn, -5) & CRLF & CRLF _
'		' & "(Purchase is Purchased minus Production so could be negative)"
'						  
						  
           
	
	End If
	j.Release
	Catch
	ToastMessageShow("ERROR: " & LastException.Message, True)	
	End Try
		
	
	'updateTimer.Enabled = True

End Sub

'Sub ReadAMData
'Dim j As HttpJob
'Dim jsRes, str1, str2, str3 As String
'Dim tNow As Long
'Dim  sQ1, sQ2 As String
'	
'	Log("readata ---------")
'Try
'	j.Initialize("", Me) 'name is empty as it is no longer needed
'	j.Download("http://192.168.1.66:4030/devices")
'	
'	
'	Wait For (j) JobDone(j As HttpJob)
'	If j.Success Then
'		jsRes = "{""Devices"": " & j.GetString & "}"
'		Log(jsRes)
'	End If
'		
'		
'	Dim JSON As JSONParser
'	Dim Map1, ameter As Map
'	'Dim contentsList As List
'		
'		
'		JSON.Initialize(jsRes)
'	Map1.initialize
'	Map1 = JSON.NextObject 'get errors here sometimes because failed to connect at line 333 so I need to catch that
'	j.Release
'	Catch
'	ToastMessageShow("ERROR: " & LastException.Message, True)
'End Try
	
'End Sub

Sub upDateSE_tick
	updateTimer.Enabled = False
	
	Log("Timer ConfigureHomeWidget")
	DownloadQuote
	'ReadAMData
	
	updateTimer.Enabled = True
End Sub



Sub EncodePath(P As String) As String
	Return su.EncodeUrl(P, "UTF8")
End Sub

Sub DecodePath(S As String) As String
	Return su.DecodeUrl(S, "UTF8")
End Sub

Sub GetTemplate(Name As String) As String
	If templates.ContainsKey(Name) Then Return templates.Get(Name)
	Dim temp As String = File.ReadString(File.DirAssets, Name)
	templates.Put(Name, temp)
	Return temp
End Sub

Sub  Datetimestring(prevQuarter As Long) As String
	Dim syr, smon, sdy, shr, smins As String
#If DEBUG
	prevQuarter = prevQuarter + DateTime.TicksPerHour 'France is 1 hour ahead always
#End If

	syr = DateTime.GetYear(prevQuarter)
	smon = DateTime.GetMonth(prevQuarter)
	If smon.Length = 1 Then smon = "0" & smon
	sdy = DateTime.GetDayOfMonth(prevQuarter)
	If sdy.Length = 1 Then sdy = "0" & sdy
	shr = DateTime.GetHour(prevQuarter)
	If shr.Length = 1 Then shr = "0" & shr
	smins = DateTime.GetMinute(prevQuarter)
	If smins.Length = 1 Then smins = "0" & smins
		
	Return  syr & "-" & smon & "-" & sdy & "%20" & shr & ":" & smins & ":00"
	
End Sub

Sub  timestring(prevQuarter As Long) As String
	Dim  shr, smins As String
#If DEBUG
	prevQuarter = prevQuarter + DateTime.TicksPerHour 'France is 1 hour ahead always
#End If

	shr = DateTime.GetHour(prevQuarter)
	If shr.Length = 1 Then shr = "0" & shr
	smins = DateTime.GetMinute(prevQuarter)
	If smins.Length = 1 Then smins = "0" & smins
		
	Return shr & ":" & smins' & ":00"
	
End Sub


Sub Service_Destroy
	server.Stop
	Service.StopForeground(1)
End Sub
